## sra-sdk 2.10.6+dfsg

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: runtests

TOP ?= $(abspath ..)
MODULE = test

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
SUBDIRS =    \
	read-filter-redact \
	prefetch        \
	dump-test       \
	vdb-config      \
	vcf-loader      \
	align-info      \
	align-cache     \
	kar             \
	copycat         \
	sra-stat        \
	srapath         \
	sra-sort        \
	sra-pileup      \
	fuse            \
	fastq-loader    \
	kget            \
	vdb-dump        \
	vdb-copy        \
	qual-recalib-stat \
	vdb-validate      \
	make-read-filter  \

# under construction
#    ngs-pileup      \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#   time of slowtests in linux release mode
# real    4m 0.076s      user    4m22.256s      sys     0m10.707s     sra-sort
# real    5m21.151s      user    5m59.396s      sys     0m39.296s     fastdump
# real    6m55.921s      user    6m28.035s      sys     6m58.052s     sra-pileup
# real  184m21.347s      user   42m19.318s      sys   259m56.028s     fuse

=== test/driver-tool/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/driver-tool

include $(TOP)/build/Makefile.env

runtests: built-in bogus container good

TMPDIR ?= /tmp
TEMPDIR ?= $(TMPDIR)

GOOD =\
	fastq-dump \
	fasterq-dump \
	sam-dump \
	sra-pileup \
	vdb-dump \
	prefetch \
	srapath

CONTAINER =\
	SRP000001 \
	SRX000001 \
	SRS000001 \
	SRA000001 \
	ERP000001 \
	DRX000001

good: $(GOOD)

container: $(CONTAINER)

$(TEMPDIR)/tmp.mkfg:
	echo '/LIBS/GUID = "c1d99592-6ab7-41b2-bfd0-8aeba5ef8498"' >$@

mkfg: $(TEMPDIR)/tmp.mkfg

actual:
	@ mkdir actual

built-in:
	@echo "running built-in tests" ; \
	SRATOOLS_TESTING=1 \
	$(BINDIR)/sratools

$(GOOD): | actual mkfg
	@# SRATOOLS_TESTING=2 skip SDL, sub-tool invocation is simulated to always
	@# succeed, but everything up to the exec call is real
	@echo "testing expected output for dry run of" $@ ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=$@ \
	$(BINDIR)/sratools SRR000001 ERR000001 DRR000001 2>actual/$@.stderr && \
	diff expected/$@.stderr actual/$@.stderr

bogus: | actual mkfg
	@echo "testing expected output for unknown tool" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_IMPERSONATE=rcexplain \
	$(BINDIR)/sratools 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

$(CONTAINER): | actual mkfg
	@echo "testing expected output for container" $@ ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools $@ 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

.PHONY: runtests bogus container good $(CONTAINER) $(GOOD)
.INTERMEDIATE: $(TEMPDIR)/tmp.mkfg

=== test/fasterq-dump/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/fasterq-dump

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

.PHONY: $(TEST_TOOLS)

slowtests: append-test

append-test: $(BINDIR)/fasterq-dump
	@./append-test.sh

=== test/fastq-loader/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

#TODO: transfer slowtests/big_loads (see CVS)

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/fastq-loader

TEST_TOOLS = \
	test-id2name \
	wb-test-fastq \
	wb-test-fastq-parse \
	test-fastq-loader

VDB_CONFIG = $(SRCDIR)

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# FASTQ parsing test
#
FASTQ_PARSE_SRC = \
	wb-test-fastq-parse

FASTQ_PARSE_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQ_PARSE_SRC))

FASTQ_PARSE_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sload \
	-sncbi-vdb \

$(TEST_BINDIR)/wb-test-fastq-parse: $(FASTQ_PARSE_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_PARSE_LIB)

parse: wb-test-fastq-parse
	$(TEST_BINDIR)/wb-test-fastq-parse  2>&1

#-------------------------------------------------------------------------------
# id2name
#
ID2NAME_TEST_SRC = \
	test-id2name

ID2NAME_TEST_OBJ = \
	$(addsuffix .$(OBJX),$(ID2NAME_TEST_SRC))

ID2NAME_TEST_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sncbi-vdb

$(TEST_BINDIR)/test-id2name: $(ID2NAME_TEST_OBJ)
	$(LP) --exe -o $@ $^ $(ID2NAME_TEST_LIB)

id: test-id2name
	$(TEST_BINDIR)/test-id2name  2>&1

#-------------------------------------------------------------------------------
# white-box test
#
FASTQ_TEST_SRC = \
	wb-test-fastq

FASTQ_TEST_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQ_TEST_SRC))

FASTQ_TEST_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sload \
	-sncbi-wvdb \

$(TEST_BINDIR)/wb-test-fastq: $(FASTQ_TEST_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_TEST_LIB)

wb: wb-test-fastq
	$(TEST_BINDIR)/wb-test-fastq  2>&1

#-------------------------------------------------------------------------------
# test-fastqtest-loader
#
FASTQTEST_LOADER_SRC = \
	test-fastq-loader

FASTQTEST_LOADER_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQTEST_LOADER_SRC))

$(TEST_BINDIR)/test-fastq-loader: $(FASTQTEST_LOADER_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_TEST_LIB)

tfl:
	$(MAKE) -C $(OBJDIR) -f $(SRCDIR)/Makefile test-fastq-loader
	$(TEST_BINDIR)/test-fastq-loader

.PHONY: test-fastq-loader

#-------------------------------------------------------------------------------
# scripted tests
#
runtests: wb parse set_schema smalltests

set_schema:
	echo "vdb/schema/paths = \"$(VDB_INCDIR)\"" > tmp.kfg

SMALLRUN = @ NCBI_SETTINGS= VDB_CONFIG=$(SRCDIR) $(SRCDIR)/runtestcase.sh $(BINDIR) $(SRCDIR)

smalltests: $(TEST_TOOLS)
	-rm -rf $(SRCDIR)/actual
#   Small tests
#   Input:
#       Quality encoding: phred/logodds, ascii/decimal
#           1.1 phred 33
	$(SMALLRUN) 1.1 0 $(SRCDIR)/input/1.1.fastq --quality PHRED_33
#           1.2 phred 64
	$(SMALLRUN) 1.2 0 $(SRCDIR)/input/1.2.fastq --quality PHRED_64
#           1.3 phred 33, decimal qualities
	$(SMALLRUN) 1.3 3 $(SRCDIR)/input/1.3.fastq --quality PHRED_33
#           1.4 logodds 64
	$(SMALLRUN) 1.4 0 $(SRCDIR)/input/1.4.fastq --quality LOGODDS
#
#       Single input file
#           2.1 reads only, basespace
	$(SMALLRUN) 2.1 0 $(SRCDIR)/input/2.1.fastq --quality PHRED_33
#           2.1.1 reads only, colorspace
#CS	$(SMALLRUN) 2.1.1 0 $(SRCDIR)/input/2.1.1.fastq --quality PHRED_33
#           2.2 qualities only
	@#-$(SMALLRUN) 2.2 0 $(SRCDIR)/input/2.2.fastq --quality PHRED_33
#           2.3 reads+qualities, qualities before reads
	@#-$(SMALLRUN) 2.3 0 $(SRCDIR)/input/2.3.fastq --quality PHRED_33
#           2.4 reads+qualities, reads before qualities
	@#-$(SMALLRUN) 2.4 0 $(SRCDIR)/input/2.4.fastq --quality PHRED_33
#           2.5 reads+qualities, paired up
	$(SMALLRUN) 2.5 0 $(SRCDIR)/input/2.5.fastq --quality PHRED_33
#           2.6 spot assembly
	$(SMALLRUN) 2.6 0 $(SRCDIR)/input/2.6.fastq --quality PHRED_33
#           2.7 spot assembly, read numbers not specified
	$(SMALLRUN) 2.7 0 $(SRCDIR)/input/2.7.fastq --quality PHRED_33
#           2.8 handling of N in reads, ALTREAD is a static column
#           TODO; investigate intermittent failure (FIXED_SPOT_LEN == 0, not 3)
	@#-$(SMALLRUN) 2.8 0 $(SRCDIR)/input/2.8.fastq --quality PHRED_33
#           2.8.1 handling of N in reads, ALTREAD is a physical column
	$(SMALLRUN) 2.8.1 0 $(SRCDIR)/input/2.8.1.fastq --quality PHRED_33
#           2.9 mismatching length of sequence and quality (qualities shorter)
	$(SMALLRUN) 2.9 3 $(SRCDIR)/input/2.9.fastq --quality PHRED_33
#           2.9.1 mismatching length of sequence and quality (qualities longer)
	$(SMALLRUN) 2.9.1 3 $(SRCDIR)/input/2.9.1.fastq --quality PHRED_33
#
#       Multiple files
#           3.1 reads+qualities together
	$(SMALLRUN) 3.1 0 $(SRCDIR)/input/3.1a.fastq $(SRCDIR)/input/3.1b.fastq --quality PHRED_33
#           3.2 qualities separately from reads, reads file comes first
	@#-$(SMALLRUN) 3.2 0 $(SRCDIR)/input/3.2a.fastq $(SRCDIR)/input/3.2b.fastq --quality PHRED_33
#           3.3 qualities separately from reads, qualities file comes first (reject?)
	@#-$(SMALLRUN) 3.3 0 $(SRCDIR)/input/3.3a.fastq $(SRCDIR)/input/3.3b.fastq --quality PHRED_33
#           3.4 default read number
#	$(SMALLRUN) 3.4 0 -r 1 $(SRCDIR)/input/3.4a.fastq -r 2 $(SRCDIR)/input/3.4b.fastq --quality PHRED_33
#
#   Command line options:
#           4.1 --tmpfs             temporary files created at the specified location
	@echo "running 4.1"; export NCBI_SETTINGS=/; export VDB_CONFIG=`pwd`; \
	 export LD_LIBRARY_PATH=$(LIBDIR);$(BINDIR)/latf-load \
	 $(SRCDIR)/input/4.fastq --tmpfs $(SRCDIR)/actual/ -v \
	 -o actual/4.1.obj --quality PHRED_33 \
	 | grep "Path for scratch files: $(SRCDIR)/actual/" >/dev/null
#           4.2 --qual-quant        quality values are quantized as specified
	$(SMALLRUN) 4.2 0 $(SRCDIR)/input/4.fastq --qual-quant 1:10,10:20,20:30,30:- --quality PHRED_33
#           4.3 --cache-size        handled correctly
	@echo "running 4.3"; export NCBI_SETTINGS=/; export VDB_CONFIG=`pwd`; \
	 export LD_LIBRARY_PATH=$(LIBDIR); \
	 $(BINDIR)/latf-load $(SRCDIR)/input/4.fastq --cache-size 10 -v \
     -o actual/4.1.obj --quality PHRED_33 \
     | grep "Cache size: 10M" >/dev/null
#           4.3.1 --cache-size      rejected if invalid
	$(SMALLRUN) 4.3.1 3 $(SRCDIR)/input/4.fastq --cache-size BIG --quality PHRED_33
#           4.4 --max-rec-count     stops at the specified record #
#CS	$(SMALLRUN) 4.4 0 $(SRCDIR)/input/4.4.fastq --max-rec-count 3 --quality PHRED_33
#           4.5 --max-err-count     stops after the specified # of errors
	$(SMALLRUN) 4.5 3 $(SRCDIR)/input/4.5.fastq --max-err-count 2 --quality PHRED_33
#           4.5.1 --max-err-pct     fails if % of error records is too high
#CS	$(SMALLRUN) 4.5.1 3 $(SRCDIR)/input/4.5.1.fastq --quality PHRED_33  --max-err-count 10 --max-err-pct 20
#           4.6 --platform          saves correct value in the PLATFORM column
	$(SMALLRUN) 4.6 0 $(SRCDIR)/input/4.fastq -p LS454 --quality PHRED_33
#           4.6.1 --platform        rejects invalid values
	$(SMALLRUN) 4.6.1 3 $(SRCDIR)/input/4.fastq -p SOMETHINGELSE --quality PHRED_33
#           4.7 input file missing
	$(SMALLRUN) 4.7 3 $(SRCDIR)/input/not_there --quality PHRED_33
#   Gzipped input
	$(SMALLRUN) 5.0 0 $(SRCDIR)/input/5.0.fastq.gz --quality PHRED_33
#   Misparsed quality
	$(SMALLRUN) 6.0 0 $(SRCDIR)/input/6.0.fastq --quality PHRED_33
#   PACBIO fastq
	$(SMALLRUN) 7.1 0 $(SRCDIR)/input/7.1.fastq --platform=PACBIO --quality PHRED_33
	$(SMALLRUN) 7.2 0 $(SRCDIR)/input/7.2.fastq --platform=PACBIO --quality PHRED_33
	$(SMALLRUN) 7.3 0 $(SRCDIR)/input/7.3.fastq --platform=PACBIO --quality PHRED_33
#   secondary read numbers other than 3
	$(SMALLRUN) 8.0 0 $(SRCDIR)/input/8.0.fastq --quality PHRED_33
#   reject inconsistent secondary read numbers
	$(SMALLRUN) 8.1 3 $(SRCDIR)/input/8.1.fastq --quality PHRED_33
#   newest Illumina tag line variation ("_" instead of " /")
	$(SMALLRUN) 9.0 0 $(SRCDIR)/input/9.0.fastq --quality PHRED_33
#   accepting ascii quality values up to 126
	$(SMALLRUN) 10.0 0 $(SRCDIR)/input/10.0.fastq --quality PHRED_33
    # 2-file fasta, tag line Run.Spot.Read
	$(SMALLRUN) 11.0 0 $(SRCDIR)/input/11.0.1.fasta $(SRCDIR)/input/11.0.2.fasta --quality PHRED_33
    # 2-file fastq, tag line Run.Spot.Read
	$(SMALLRUN) 11.1 0 $(SRCDIR)/input/11.1.1.fastq $(SRCDIR)/input/11.1.2.fastq --quality PHRED_33
    # Illumina, ignore barcodes
	$(SMALLRUN) 12.0 0 $(SRCDIR)/input/12.0.fastq --quality PHRED_33 --ignore-illumina-tags
    # Illumina, use barcodes as spotgroups
	$(SMALLRUN) 12.1 0 $(SRCDIR)/input/12.1.fastq --quality PHRED_33
    # Illumina, use barcodes as spotgroups, alternative format
	$(SMALLRUN) 12.2 0 $(SRCDIR)/input/12.2.fastq --quality PHRED_33
    # Consume our own dog food (13.0.fastq created by fastq-dump )
	$(SMALLRUN) 13.0 0 $(SRCDIR)/input/13.0.fastq --quality PHRED_33
    # Consume our own dog food (13.1.fastq created by fastq-dump -F )
	$(SMALLRUN) 13.1 0 $(SRCDIR)/input/13.1.fastq --quality PHRED_33
    # SRA-2932: 30 is the preferred value for qualities when reading FASTA
	$(SMALLRUN) 14.0 0 $(SRCDIR)/input/14.0.fasta $(SRCDIR)/input/14.0.fasta --quality PHRED_33
    # VDB-3154: buffer insufficient
	$(SMALLRUN) 15.0 0 $(SRCDIR)/input/15.0.fastq --quality PHRED_33
    # VDB-3413: multi-line reads and qualities
	$(SMALLRUN) 16.0 0 $(SRCDIR)/input/16.0.fasta --quality PHRED_33 --platform=PACBIO
	$(SMALLRUN) 16.1 0 $(SRCDIR)/input/16.1.fastq --quality PHRED_33 --platform=PACBIO
	#
	#rm -rf $(SRCDIR)/actual

onetest:
	rm -rf $(SRCDIR)/actual
	$(SMALLRUN) 8.1 3 $(SRCDIR)/input/8.1.fastq --quality PHRED_33

=== test/kar/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/kar

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

runtests: kar_test 

#-------------------------------------------------------------------------------
# scripted tests
#
kar_test: kar-ntest.sh
	@ echo "Starting kar tests..."
	@ NCBI_SETTINGS=/ bash kar-ntest.sh $(BINDIR)/kar

.PHONY: $(TEST_TOOLS)

clean: stdclean

=== test/kget/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/kget

TEST_TOOLS = \

include $(TOP)/build/Makefile.env

.PHONY: $(TEST_TOOLS)

#-------------------------------------------------------------------------------
# runtests: 
#
ifdef PYTHON
runtests: download

else
runtests: ;

endif

download:
	export PATH=$(BINDIR):$$PATH; export VDB_CONFIG=`pwd` ; \
		NCBI_SETTINGS=/ $(PYTHON) test_kget.py # expect rc = 0 

#-------------------------------------------------------------------------------
# slowtests: match output vs wget
#

slowtests: diff-vs-wget

ACCESSION = SRR072810
NAME = $(ACCESSION).4
HOST = sra-download-internal.ncbi.nlm.nih.gov
URL = https://$(HOST)/sos/sra-pub-run-1/$(ACCESSION)/$(NAME)

clean:
	rm -f $(ACCESSION)*

diff-vs-wget: clean
	$(BINDIR)/kget --reliable -c ./$(ACCESSION).cachetee $(URL) $(ACCESSION).dat --progress
	wget --no-check-certificate $(URL)
	diff ./$(NAME) ./$(ACCESSION).dat
	#diff $(ACCESSION).sra ./$(ACCESSION).cachetee
	rm -f $(ACCESSION)*


.PHONY:

=== test/make-read-filter/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/make-read-filter

include $(TOP)/build/Makefile.env

TMPDIR ?= /tmp
TEMPDIR ?= $(TMPDIR)

$(TEMPDIR)/tmp.mkfg:
	@ echo '/LIBS/GUID = "c1d99592-6ab7-41b2-bfd0-8aeba5ef8498"' >$@; \
	  echo '/sra/quality_type = "raw_scores"' >>$@

mkfg: $(TEMPDIR)/tmp.mkfg

exe: $(BINDIR)/make-read-filter $(BINDIR)/vdb-dump $(BINDIR)/kar

test-data.kar: generate-test-data.py | mkfg exe
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	VDB_LIBRARY_PATH=$(VDB_LIBDIR) \
	python3 $^ $(TEMPDIR)/test-data && \
	$(BINDIR)/kar -d $(TEMPDIR)/test-data -fc $@ && \
	rm -rf $(TEMPDIR)/test-data expected

runtests: test-data.kar | mkfg exe
	$(BINDIR)/kar -d $(TEMPDIR)/test-data -x test-data.kar && \
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	$(BINDIR)/make-read-filter --temp $(TEMPDIR) $(TEMPDIR)/test-data && \
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	$(BINDIR)/vdb-dump $(TEMPDIR)/test-data >actual && \
	rm -rf $(TEMPDIR)/test-data && \
	diff expected actual

.PHONY: runtests
.INTERMEDIATE: $(TEMPDIR)/tmp.mkfg

=== test/prefetch/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests
TOP ?= $(abspath ../..)
include $(TOP)/build/Makefile.env

CWD = $(shell pwd)
PUBLIC=/repository/user/main/public
CGI=https://trace.ncbi.nlm.nih.gov/Traces/names/names.fcgi
SDL=https://locate.ncbi.nlm.nih.gov/sdl/2/retrieve
LARGE=fasp://aspera@demo.asperasoft.com:aspera-test-dir-large/100MB
SRA=https://sra-download.ncbi.nlm.nih.gov
SRAF=fasp://dbtest@sra-download.ncbi.nlm.nih.gov
#SRAF=fasp://dbtest@srafiles31-1.st-va.ncbi.nlm.nih.gov
KMER=$(SRA)/traces/nannot01/kmer/000/390/GCA_000390265.1_R
KMERF=$(SRAF):data/sracloud/traces/nannot01/kmer/000/390/GCA_000390265.1_R
REFSEQ=$(SRA)/traces/refseq/KC702174.1
REFSEQF=$(SRAF):data/sracloud/traces/refseq/KC702174.1
SRAC=SRR053325
SRR=$(SRA)/sos2/sra-pub-run-15/$(SRAC)/$(SRAC).4
INT=https://sra-download-internal.ncbi.nlm.nih.gov
DDB=https://sra-downloadb.be-md.ncbi.nlm.nih.gov
#SRR=$(DDB)/sos/sra-pub-run-5/$(SRAC)/$(SRAC).3
SRAI=fasp://dbtest@sra-download-internal.ncbi.nlm.nih.gov
SRRF=$(SRAF):data/sracloud/traces/sra57/SRR/000052/$(SRAC)
SRRF=$(SRAI):data/sracloud/traces/sra57/SRR/000052/$(SRAC)
WGS=$(SRA)/traces/wgs03/WGS/AF/VF/AFVF01.1
WGSF=$(SRAF):data/sracloud/traces/wgs03/WGS/AF/VF/AFVF01.1
B=$(BINDIR)

HTTP_URL=https://test.ncbi.nlm.nih.gov/home/about/contact.shtml
HTTPFILE=contact.shtml

runtests: urls_and_accs out_dir_and_file s-option truncated kart wgs resume
slowtests: hs37d5 ncbi1GB

################################################################################
urls_and_accs:
	@mkdir -p tmp tmp2
	@rm -fr tmp/* tmp2/*
	@echo 'foo = "bar"' > tmp/t.kfg

	@echo prefetch URL-1 when there is no kfg
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ngs/wiki > /dev/null

	@echo prefetch URL-2/2 when there is no kfg
	@rm -f index.html
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ >/dev/null

	@echo prefetch URL-2/1 when there is no kfg
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if ping -c1 intranet > /dev/null ; then \
	       $(BINDIR)/prefetch http://intranet/ >/dev/null ; \
	    fi

	@echo prefetch URL-2/3 when there is no kfg
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if ping -c1 intranet > /dev/null ; then \
	     $(BINDIR)/prefetch $(HTTP_URL)  > /dev/null; \
	    fi

	@echo '$(PUBLIC)/apps/file/volumes/flat = "files"' > tmp/t.kfg
	@echo '$(PUBLIC)/root = "$(CWD)/tmp"' >> tmp/t.kfg

	@if ls `pwd`/tmp2/$(HTTPFILE) 2> /dev/null ; \
     then echo $(HTTPFILE) found ; exit 1 ; fi
	@echo HTTP download when user repository is configured
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    if ping -c1 intranet > /dev/null ; then \
	    $(BINDIR)/prefetch $(HTTP_URL) > /dev/null ; fi
	@if ping -c1 intranet > /dev/null ; \
	 then ls `pwd`/tmp2/$(HTTPFILE) > /dev/null ; fi

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	 if ping -c1 intranet > /dev/null ; then \
	     $(BINDIR)/prefetch $(HTTP_URL) \
	        | grep "found local" > /dev/null ; fi

	@rm -f $(HTTPFILE)

	@if ls `pwd`/tmp2/index.html 2> /dev/null ; \
     then echo index.shtml found ; exit 1; fi
	@echo HTTP download when user repository is configured
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	 if ping -c1 intranet > /dev/null ; then \
	    $(BINDIR)/prefetch http://intranet/ > /dev/null ; fi
	@if ping -c1 intranet>/dev/null; then ls `pwd`/tmp2/index.html > /dev/null;fi

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	 if ping -c1 intranet > /dev/null ; then \
	    $(BINDIR)/prefetch http://intranet/ | grep "found local" > /dev/null ; fi
	@rm -f tmp2/index.html

	@echo URL download when user repository is configured
	@if ls `pwd`/tmp2/wiki 2> /dev/null ; then echo wiki found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ngs/wiki > /dev/null
	@ls `pwd`/tmp2/wiki > /dev/null

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ngs/wiki \
	                              | grep "found local" > /dev/null

	@echo URL/ download when user repository is configured
	@if ls `pwd`/tmp2/index.html 2> /dev/null ; \
     then echo index.html found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/ > /dev/null
	@ls `pwd`/tmp2/index.html > /dev/null

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; cd tmp2 ; \
	    $(BINDIR)/prefetch https://github.com/ncbi/|grep "found local">/dev/null

	@echo prefetch $(SRR) when there is no kfg
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRR) > /dev/null
	@rm -r $(SRAC)

	@echo '$(PUBLIC)/apps/sra/volumes/sraFlat = "sra"' >> tmp/t.kfg
	@rm -f `pwd`/tmp/sra/$(SRAC).sra
	@echo SRR download when user repository is configured
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRR) > /dev/null
	@ls `pwd`/tmp/sra/$(SRAC).sra > /dev/null

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRR) | grep "found local" > /dev/null

	@echo prefetch $(REFSEQ) when there is no kfg
	@rm -f KC702174.1
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(REFSEQ) > /dev/null
	@rm KC702174.1

	@echo '$(PUBLIC)/apps/refseq/volumes/refseq = "refseq"' >> tmp/t.kfg
	@echo REFSEQ HTTP download when user repository is configured
	@if ls `pwd`/tmp/refseq/KC702174.1 2> /dev/null ; \
     then echo KC702174.1 found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(REFSEQ) > /dev/null
	@ls `pwd`/tmp/refseq/KC702174.1 > /dev/null

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(REFSEQ) | grep "found local" > /dev/null

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch $(KMER) > /dev/null 2>&1 ; \
        then echo "prefetch $(KMER) when there is no kfg should fail"; exit 1; \
	    fi

	@echo '$(PUBLIC)/apps/nakmer/volumes/nakmerFlat = "nannot"' >> tmp/t.kfg
	@echo NANNOT download when user repository is configured
	@if ls `pwd`/tmp/nannot/GCA_000390265.1_R 2> /dev/null ; \
     then echo GCA_000390265.1_R found ; exit 1 ; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(KMER) > /dev/null
	@ls `pwd`/tmp/nannot/GCA_000390265.1_R > /dev/null

	@echo Running prefetch second time finds previous download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(KMER) | grep "found local" > /dev/null

	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch $(WGS) > /dev/null 2>&1 ; \
        then echo "prefetch $(WGS) when there is no kfg should fail" ; exit 1; \
	    fi

	@echo '$(PUBLIC)/apps/wgs/volumes/wgsFlat = "wgs"' >> tmp/t.kfg
	@echo
	@echo WGS HTTP download when user repository is configured
	@if ls `pwd`/tmp/wgs/AFVF01 2> /dev/null ; \
		then echo AFVF01 found ; exit 1; fi
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(WGS) > /dev/null
	@echo INCORRECT DOWNLOAD OF WGS SHOULD BE FIXED: VDB-3537
	@ls `pwd`/tmp/wgs/AFVF01 > /dev/null ;
	@echo

	@rm -f `pwd`/tmp/sra/$(SRAC).sra
	@ echo SRR FASP download when user repository is configured IS DISABLED
#	@ if [ "${HAVE_NCBI_ASCP}" = "1" ] ; then \
	    echo SRR FASP download when user repository is configured ; \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRRF) > /dev/null ; \
	    ls `pwd`/tmp/sra/$(SRAC).sra > /dev/null ; \
	 else echo download of $(SRRF) when ascp is not found is disabled ; \
	 fi

	@rm -f `pwd`/tmp/refseq/KC702174.1
	@ if [ "${HAVE_NCBI_ASCP}" = "1" ] ; then \
	    echo REFSEQ FASP download when user repository is configured ; \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	      $(BINDIR)/prefetch $(REFSEQF) > /dev/null ; \
	    ls `pwd`/tmp/refseq/KC702174.1 > /dev/null ; \
	 else echo download of $(REFSEQF) when ascp is not found is disabled ; \
	 fi

	@rm `pwd`/tmp/nannot/GCA_000390265.1_R
	@echo NANNOT FASP download when user repository is configured
	@ if [ "${HAVE_NCBI_ASCP}" = "1" ] ; then \
	    echo NANNOT FASP download when user repository is configured ; \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	      $(BINDIR)/prefetch $(KMERF) > /dev/null ; \
	      ls `pwd`/tmp/nannot/GCA_000390265.1_R > /dev/null ; \
	 else echo download of $(KMERF) when ascp is not found is disabled ; \
	 fi

	@rm `pwd`/tmp/wgs/AFVF01
	@if ls `pwd`/tmp/wgs/AFVF01 2> /dev/null ; \
     then echo AFVF01 found ; exit 1; fi
	@ if [ "${HAVE_NCBI_ASCP}" = "1" ] ; then echo ; \
	    echo WGS FASP download when user repository is configured ; \
	    export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	      $(BINDIR)/prefetch $(WGSF) > /dev/null ; \
	    echo INCORRECT DOWNLOAD OF WGS SHOULD BE FIXED: VDB-3537 ; \
	    ls `pwd`/tmp/wgs/AFVF01 > /dev/null ; \
	 else echo download of $(WGSF) when ascp is not found is disabled ; \
	 fi
	@echo

	@rm -f `pwd`/tmp/sra/$(SRAC).sra
#	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    if $(BINDIR)/prefetch $(SRAC) 2> /dev/null ; \
        then echo "prefetch $(SRAC) when there is no kfg should fail" ; \
             exit 1; \
	    fi

	@echo 'repository/remote/main/CGI/resolver-cgi = "$(CGI)"' >> tmp/t.kfg
	@echo SRR accession download
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch $(SRAC) > /dev/null
	@ls `pwd`/tmp/sra/$(SRAC).sra > /dev/null

	@echo prefetch run with refseqs
	@rm -fr `pwd`/SRR619505
	@rm -fv `pwd`/tmp/sra/SRR619505.sra
	@rm -fv `pwd`/tmp/refseq/NC_000005.8
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch SRR619505 > /dev/null
	@ls `pwd`/tmp/sra/SRR619505.sra > /dev/null
	@ls `pwd`/tmp/refseq/NC_000005.8 > /dev/null

	@echo REFSEQ accession download
	@rm -f `pwd`/tmp/refseq/KC702174.1
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \
	    $(BINDIR)/prefetch KC702174.1 > /dev/null
	@ls `pwd`/tmp/refseq/KC702174.1 > /dev/null

	@echo NANNOT accession download
	@rm -f `pwd`/tmp/nannot/GCA_000390265.1_R
	@export VDB_CONFIG=`pwd`/tmp; export NCBI_SETTINGS=/ ; \

=== test/sra-pileup/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/sra-pileup

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

ifdef PYTHON
runtests: check_exit_code check_skiplist

slowtests: fastq_dump_vs_sam_dump sam_dump_spotgroup_for_all

else
runtests: ;

slowtests: ;

endif

#-------------------------------------------------------------------------------
# scripted tests
#

check_exit_code:
	@ NCBI_SETTINGS=/ $(PYTHON) $(TOP)/build/check-exit-code.py $(BINDIR)/sra-pileup

check_skiplist:
	@ NCBI_SETTINGS=/ $(PYTHON) check_skiplist.py $(BINDIR)/sra-pileup

ACC = SRR3332402

#-------------------------------------------------------------------------------
# testing if sam-dump and fastq-dump produce the same READ/QUALITY values
#
fastq_dump_vs_sam_dump :
	@ NCBI_SETTINGS=/ $(PYTHON) test_diff_fastq_dump_vs_sam_dump.py -a $(ACC) -f $(BINDIR)/fastq-dump -m $(BINDIR)/sam-dump

#-------------------------------------------------------------------------------
# testing if sam-dump and fastq-dump produce the same READ/QUALITY values
#
sam_dump_spotgroup_for_all :
	@ NCBI_SETTINGS=/ $(PYTHON) test_all_sam_dump_has_spotgroup.py -a $(ACC) -m $(BINDIR)/sam-dump

.PHONY: $(TEST_TOOLS)

clean: stdclean

=== test/sra-sort/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
include $(TOP)/build/Makefile.env # BINDIR

default: runtests

slowtests: test-copy

test-copy:
	PATH=$(BINDIR):$(PATH) ./md-created.sh

=== test/sra-stat/Makefile ===
# ==============================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ==============================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/sra-stat

TEST_TOOLS = \
	testAssemblyStatistics

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------

SRC = \
	testAssemblyStatistics

OBJ = \
	$(addsuffix .$(OBJX),$(SRC))

LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb \

$(TEST_BINDIR)/testAssemblyStatistics: $(OBJ)
	$(LP) --exe -o $@ $^ $(LIB)

#-------------------------------------------------------------------------------

runtests: test_bases Mismatch

slowtests: slow_bases

quick_bases:
	@rm   -rf actual
	@mkdir -p actual

	@echo
	@echo SRR053325 is a small table
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR053325 > actual/SRR053325
	diff actual/SRR053325 expected/SRR053325-biological-reloaded

	@echo
	@echo SRR600096 is a small non-cSRA DB
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR600096 > actual/SRR600096
	diff actual/SRR600096 expected/SRR600096

	@echo
	@echo SRR618333 is a small CS_NATIVE table
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR618333 > actual/SRR618333
	diff actual/SRR618333 expected/SRR618333

	@echo
	@echo SRR413283 is a small cSRA with local references
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR413283 > actual/SRR413283
	diff actual/SRR413283 expected/SRR413283-with-AssemblyStatistics

	@echo
	@echo SRR619505 is a small cSRA with N-s without local references
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR619505 | perl -w strip-path.pl \
	                                                > actual/SRR619505
	diff actual/SRR619505 expected/SRR619505

	@echo
	@echo SRR1985136 is a small cSRA with a local reference and 0-length tech-rd
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR1985136 | perl -w strip-path.pl \
                                                    > actual/SRR1985136
	diff actual/SRR1985136 expected/SRR1985136-with-Changes

	@echo
	@rm actual/*

R=SRR8483030
test_bases: quick_bases
	@echo
	@echo ${R} is a run having first 0-lenght bio reads
	if perl check-run-perm.pl $(BINDIR)/srapath ${R} > /dev/null 2>&1 ; \
	then                      $(BINDIR)/sra-stat -x ${R} > /dev/null ; fi

	@echo
	@echo SRR495844 is a cSRA with local references
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR495844 | perl -w strip-path.pl \
                                                    > actual/SRR495844
	diff actual/SRR495844 expected/SRR495844-with-Changes

	@echo
	@echo SRR390427 is a non-cSRA DB
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR390427 > actual/SRR390427
	diff actual/SRR390427 expected/SRR390427

	@echo
	@echo SRR360929 is a table
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR360929 > actual/SRR360929
	diff actual/SRR360929 expected/SRR360929-biological

	@echo
	@rm    actual/*
	@rm -r actual

slow_bases:
	@rm   -vrf actual
	@mkdir -vp actual

	@echo
	@echo SRR586259 is a cSRA without local references
	NCBI_SETTINGS=/ $(BINDIR)/sra-stat -x SRR586259 | perl -w strip-path.pl \
                                                    > actual/SRR586259
	diff actual/SRR586259 expected/SRR586259

	@echo
	@rm -v  actual/*
	@rm -vr actual

all_bases: test_bases slow_bases

Mismatch:
	@mkdir -p actual
	@$(BINDIR)/sra-stat db/SRR6336806.Mismatch >/dev/null 2> actual/Mismatch
	@if grep -q 'Mismatch between calculated and recorded statis' actual/Mismatch;\
	 then echo "Mismatch between calculated and recorded statists was found"; \
		exit 1; fi
	echo Mismatch OK
	@rm -r actual

slowest_bases:
	NCBI_SETTINGS=/ time $(BINDIR)/sra-stat -xp SRR5362833

#-------------------------------------------------------------------------------

=== test/srapath/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/srapath

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

ifdef PYTHON
runtests: check_exit_code SRP vdbcache

else
runtests: SRP vdbcache

endif

#-------------------------------------------------------------------------------
# scripted tests
#

check_exit_code:
	@ $(PYTHON) $(TOP)/build/check-exit-code.py $(BINDIR)/srapath

SRP:
# TODO: TEMPORARELY DISABLED:	$(BINDIR)/srapath SRP000001 -+VFS # works & does not crash
	@ NCBI_SETTINGS=/ $(BINDIR)/srapath SRR000001 -fnames > /dev/null

vdbcache: #; print "<$_>"
	@ NCBI_SETTINGS=/ $(BINDIR)/srapath SRR1557953 | wc -l | perl check-cnt.pl

.PHONY: $(TEST_TOOLS)

clean: stdclean

=== debian/changelog ===
sra-sdk (2.10.6+dfsg-4) unstable; urgency=medium

  * Account for new sratools setup.  (Closes: #961256.)
    - debian/rules: Rework deversioning logic to account for sratools and
      *-orig.* while still keeping hardcoding to a minimum; formally
      supply a hardcoded but originally random standard installation ID in
      a new /etc/ncbi/debian.kfg.
    - debian/patches/use_unversioned_tools.patch (new): Have sratools look
      for executable names without version extensions.

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 22 May 2020 09:25:13 -0400

sra-sdk (2.10.6+dfsg-3) unstable; urgency=medium

  * Also exclude sra-pileup check_skiplist test per network access.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 21 May 2020 10:17:04 -0400

sra-sdk (2.10.6+dfsg-2) unstable; urgency=medium

  * drop_tests.patch: Exclude kar (needs network access); retire
    test-vdb-config exclusion with (fake)root out of the picture.
    Update description accordingly.
  * ignore_failing_test_for_the_moment_FIXME.patch: Resync.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 21 May 2020 09:03:42 -0400

sra-sdk (2.10.6+dfsg-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.1

  * ncbi-vdb needs to appear as 2.10.2 in Debian with its mbedtls wrapper
    fixed to avoid a link error in this package.

  [ Michael R. Crusoe ]
  * Convert to Python3. Closes: #943231
  * Standards-Version: 4.5.0 (routine-update)

  [ Aaron M. Ucko ]
  * Correct accidental cutover to ncbi-vdb 2.10.5(+dfsg); further update to
    2.10.6.
  * Revert patch updates contingent on spurious cutover to ncbi-vdb.
  * Refresh patches for real.
    - Generally standardize on -pab format.
    - hardening.patch: Rebase C(P)FLAGS, which no longer request extensions.
    - python3: Drop makefile tweaks obsoleted by new PYTHON abstraction.
  * Help validate-names4.c find ncbi-vdb headers that are normally internal.
    To wit, build-depend on libncbi-vdb-dev (>= 2.10.6+dfsg-2~) to ensure
    these headers are installed sanely, and patch validate-names4.c
    accordingly in a new patch use_exposed_headers.patch.  In conjunction
    with taking the latest upstream, closes: #961049.
  * Specify configuration location by passing KONFIG_DIR.  (The makefile
    patch previously in use relied on [fake]root.)
  * Fix usage of default Debian build flags: Use buildflags.mk with
    appropriate _APPEND settings, and tweak hardening.patch to add
    DEB_*FLAGS to the front rather than the end (so as to keep upstream's
    preferred optimization level).
  * Preclean more fully to allow for consecutive builds.
  * List (wildcard) currently uninstalled files in debian/not-installed.
  * Correct logic for identifying all failing tests when there are any.
  * Secure URI in copyright format (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Add myself to uploaders.

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 20 May 2020 22:15:19 -0400

sra-sdk (2.9.4+dfsg-1) unstable; urgency=medium

  * Team upload.

  * New upstream version.
  * Bumped policy to 4.3.0

 -- Steffen Moeller <moeller@debian.org>  Tue, 26 Feb 2019 15:01:51 +0100

=== debian/control ===
Source: sra-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
	   Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libngs-sdk-dev (>= 2.9.0),
               libncbi-vdb-dev (>= 2.10.6+dfsg-2~),
               libvdb-sqlite-dev,
               libfuse-dev,
               libhdf5-dev,
               libmagic-dev,
               libxml2-dev,
               python3
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/sra-sdk
Vcs-Git: https://salsa.debian.org/med-team/sra-sdk.git
Homepage: https://github.com/ncbi/sra-tools/
Rules-Requires-Root: no

Package: sra-toolkit
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: med-config (>= 2.1)
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 Other tools distributed in this package are:
  abi-dump, abi-load
  align-info
  bam-load
  cache-mgr
  cg-load
  copycat
  fasterq-dump
  fastq-dump, fastq-load
  helicos-load
  illumina-dump, illumina-load
  kar
  kdbmeta
  latf-load
  pacbio-load
  prefetch
  rcexplain
  remote-fuser
  sff-dump, sff-load
  sra-pileup, sra-sort, sra-stat, srapath
  srf-load
  test-sra
  vdb-config, vdb-copy, vdb-decrypt, vdb-encrypt, vdb-get, vdb-lock,
  vdb-passwd, vdb-unlock, vdb-validate
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

=== debian/rules ===
#!/usr/bin/make -f

# Pregenerated with uuidgen -r
DEBIAN_GUID = 806b5c3b-0088-4732-8359-51630950d723

# +pie breaks the build
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

pkg := sra-toolkit

export DEB_CFLAGS_MAINT_APPEND   = -I/usr/include/ncbi-vdb
export DEB_CXXFLAGS_MAINT_APPEND = -I/usr/include/ncbi-vdb
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --no-parallel

OUTDIR=$(CURDIR)/debian/tmp
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_clean:
	-dh_auto_clean

override_dh_clean:
	dh_clean
	rm -f reconfigure build/ld.linux.exe_cmd.sh build/Makefile.config build/Makefile.config.linux.x86_64
	rm -rf test/*/actual test/*/tmp.kfg tools/kqsh/kqsh-sra.[ch]

override_dh_update_autotools_config:
	echo "do nothing"

override_dh_auto_configure:
	# output dir will be checked so create it before
	mkdir -p debian/tmp/usr/lib
	ln -s /usr/lib/$(MULTIARCH) debian/tmp/usr/lib
	#
        # that's no standard configure script lacking support of default options
	#
	# --with-debug sets some options that require header files like compiler.h which
	# is internal to ncbi-vcb and not installed into the package - so this option
	# should not be used.
	./configure --build=$(MULTIARCH) --prefix=$(CURDIR)/debian/tmp/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr

override_dh_auto_build:
	export LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$(OUTDIR)/lib"; export OUTDIR=$(OUTDIR) ; make DEB_CFLAGS="$(CFLAGS)" DEB_CXXFLAGS="$(CXXFLAGS)" DEB_LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install -- KONFIG_DIR=$(CURDIR)/debian/sra-toolkit/etc/ncbi

override_dh_install:
	# upstream installs versioned *.a libs - we only want a single version
	ls -l debian/tmp/usr/bin
	cd debian/tmp/usr/bin && \
	for bin in *-orig.* ; do \
	    base=$${bin%-orig.*} && \
	    vbase=$$(readlink "$$(readlink $$base)") && \
	    vdriver=$$(readlink "$$vbase") && \
	    mv -v $$bin $$base-orig && \
	    ln -snfv $${vdriver%%.[0-9]*} $$vbase || exit $$? ; \
	done && \
	for bin in *[a-z] ; do \
	    bin2=$$(readlink $$bin) ; \
	    bin3=$$(readlink "$$bin2") ; \
	    case $$bin2 in \
	        $$bin.* ) rm -v $$bin2 && mv -v $$bin3 $$bin || exit $$? ;; \
	    esac ; \
	done
	dh_install
	# remove susipcious file which is not executable and conflicts with package magic
	rm -f debian/*/usr/bin/magic
	# rename kget which conflicts with kget download manager (see #851219)
	mv debian/$(pkg)/usr/bin/kget debian/$(pkg)/usr/bin/vdb-get
	# Formally supply a standard installation ID to satisfy sratools
	echo '/LIBS/GUID = "$(DEBIAN_GUID)"' >debian/$(pkg)/etc/ncbi/debian.kfg

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- -k
endif

override_dh_prep:
	dh_prep -X debian/tmp
